#include <stdlib.h>
#include <stdio.h>
#include <qdos.h>
#include <qptr.h>
#include <string.h>
#include <libsprt.h>
#include <xmenu.h>
#include <sys/stat.h>

#include "main.h"
#include "demo.h"
#include "couleur.h"
#include "multilang.h"
#include "color.h"

#define min(a,b) ((a)<(b)?(a):(b))

static char q256_header[]= { 2,16,00 };
static char q40_header[]= { 2,33,00 };
static char ql4_header[]= { 1, 0, 0 };
static char ql8_header[]= { 1, 1, 0 };

void read_demo(char moda, FILE * fd,int fd1)
{
unsigned short xpos,ypos,round;
unsigned long keep,dummy;

struct stat buf;
unsigned long taille;
unsigned char * bloc;
unsigned char * cursor;
unsigned long debut;
char deb[12];
unsigned char * q40,*ql4,*ql8,*q256;
int i,j;
unsigned short *curs;
int kkkk = editor_mode;
  if (fstat(fd1,&buf))
  {
  Message_Report(DefaultColourSet(),mess[MS_FSTAT][conf_lang]);
  return;
  }
  taille = (unsigned long) buf.st_size;

  if (!taille)
  {
  Message_Report(DefaultColourSet(),mess[MS_FNULL][conf_lang]);
  return;
  }
  debut = 0;
  if (String_Edit(DefaultColourSet(),mess[MS_DRECH][conf_lang],mess[MS_DRECH_E][conf_lang],"0",10,deb)>0)
  {
  debut = (unsigned long) atoi(deb);
  }

  bloc = malloc(taille);
  if (!bloc)
  {
    Message_Report(DefaultColourSet(),mess[MS_MEMPB][conf_lang]);
    return;
  }
  fread(bloc,1,taille,fd);

  q40=0;ql4=0;ql8=0;q256=0;
  for(cursor=bloc+debut;cursor<bloc+taille-3;cursor++)
  {
     if ((!q40)&&(moda&0x04)&&(!memcmp(cursor,q40_header,sizeof(q40_header))))
     {
         q40 = cursor;
     xpos = (q40[4]<<8) | q40[5];
     ypos = (q40[6]<<8) | q40[7];

     if ((xpos)&&(ypos)&&(xpos<=GRIDX)&&(ypos<=GRIDY))
     {
     q40[8] = q40[9] = q40[10] = q40[11] = 0;
     q40[20] = q40[21] = q40[22] = q40[23] = 0;
        if (XDialog(DefaultColourSet(),mess[MS_THISP][conf_lang],mess[MS_THATP][conf_lang],(struct WM_sprite *)q40,0))
        {
         q40=0;
        }
     }
     else { q40 = 0; }
     }
     if ((!q256)&&(moda&0x08)&&(!memcmp(cursor,q256_header,sizeof(q256_header))))
     {
         q256 = cursor;
     xpos = (q256[4]<<8) | q256[5];
     ypos = (q256[6]<<8) | q256[7];

     if ((xpos)&&(ypos)&&(xpos<=GRIDX)&&(ypos<=GRIDY))
     {
     q256[8] = q256[9] = q256[10] = q256[11] = 0;
     q256[20] = q256[21] = q256[22] = q256[23] = 0;
        if (XDialog(DefaultColourSet(),mess[MS_THISP256][conf_lang],mess[MS_THATP256][conf_lang],(struct WM_sprite *)q256,0))
        {
         q256=0;
        }
     }
     else { q256 = 0; }
     }

     if ((!ql4)&&(moda&0x02)&&(!memcmp(cursor,ql4_header,sizeof(ql4_header))))
     {
         ql4 = cursor;
     xpos = (ql4[4]<<8) | ql4[5];
     ypos = (ql4[6]<<8) | ql4[7];
     if ((xpos)&&(ypos)&&(xpos<=GRIDX)&&(ypos<=GRIDY))
     {
     ql4[8] = ql4[9] = ql4[10] = ql4[11] = 0;
     ql4[20] = ql4[21] = ql4[22] = ql4[23] = 0;
        if (XDialog(DefaultColourSet(),mess[MS_THISP][conf_lang],mess[MS_THATP_M4][conf_lang],(struct WM_sprite *)ql4,0))
        {
         ql4=0;
        }
     }
     else { ql4 = 0; }
     }
     if ((!ql8)&&(moda&0x01)&&(!memcmp(cursor,ql8_header,sizeof(ql8_header))))
     {
         ql8 = cursor;
     xpos = (ql8[4]<<8) | ql8[5];
     ypos = (ql8[6]<<8) | ql8[7];
     if ((xpos)&&(ypos)&&(xpos<=GRIDX)&&(ypos<=GRIDY))
     {
         ql8[20] = ql8[21] = ql8[22] = ql8[23] = 0;
         ql8[8] = ql8[9] = ql8[10] = ql8[11] = 0;
         ql8[1] = 0;
        if (XDialog(DefaultColourSet(),mess[MS_THISP][conf_lang],mess[MS_THATP_M8][conf_lang],(struct WM_sprite *)ql8,0))
        {
         ql8=0;
        }
        ql8[1]= 1;
     }
     else { ql8 = 0; }
     }
  }

  if ((moda & 0x04)&&q40)
  {
     xpos = (q40[4]<<8) | q40[5];
     ypos = (q40[6]<<8) | q40[7];
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = q40;
     cursor += (q40[12]<<24)|(q40[13]<<16)|(q40[14]<<8)|q40[15];
     cursor += 12;
     round = (xpos+1) & 0xFFFE;
     editor_mode =40;
     colorpattern(editor_mode,&keep,&dummy);
     top=0;
     bottom=ypos;
     lefti=0;
     righti=xpos;
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
        the_sprite[j][i] &= keep;
        the_sprite[j][i] |= ((*cursor)<<24) | ((*(cursor+1))<<16);
        cursor+=2;
     }
     cursor = q40;
     cursor += (q40[16]<<24)|(q40[17]<<16)|(q40[18]<<8)|q40[19];
     cursor += 16;
     maskpattern(editor_mode,&keep,&dummy);
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
        the_mask[j][i] &= keep;
        if (*cursor) { the_mask[j][i] |= dummy; }
        cursor += 2;
     }
     update_dimension();
     update_demo();
    }
  }

  if ((moda & 0x08)&&q256)
  {
     xpos = (q256[4]<<8) | q256[5];
     ypos = (q256[6]<<8) | q256[7];
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = q256;
     cursor += (q256[12]<<24)|(q256[13]<<16)|(q256[14]<<8)|q256[15];
     cursor += 12;
     round = (xpos+3) & 0xFFFC;
     editor_mode =256;
     colorpattern(editor_mode,&keep,&dummy);
     top=0;
     bottom=ypos;
     lefti=0;
     righti=xpos;
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
        the_sprite[j][i] &= keep;
        the_sprite[j][i] |= ((*cursor & 0xFE)<<8) | ((*cursor & 0x01)<<7);
        cursor++;
     }
     cursor = q256;
     cursor += (q256[16]<<24)|(q256[17]<<16)|(q256[18]<<8)|q256[19];
     cursor += 16;
     maskpattern(editor_mode,&keep,&dummy);
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
        the_mask[j][i] &= keep;
        if (*cursor) { the_mask[j][i] |= dummy; }
        cursor ++;
     }
     update_dimension();
     update_demo();
    }
  }

  if ((moda & 0x02)&&ql4)
  {
     int k;
     unsigned short xtr;
     xpos = (ql4[4]<<8) | ql4[5];
     ypos = (ql4[6]<<8) | ql4[7];
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = ql4;
     cursor += (ql4[12]<<24)|(ql4[13]<<16)|(ql4[14]<<8)|ql4[15];
     cursor += 12;
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 4;
     top=0;
     bottom=ypos;
     lefti=0;
     righti=xpos;
     colorpattern(editor_mode,&keep,&dummy);
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<8;k++)
     {
        if (i*8+k<GRIDX)
        {
        the_sprite[j][i*8+k] &= keep;
        the_sprite[j][i*8+k] |= (xtr & (0x0101 <<(7-k)))>>(7-k);
        }
     }
     cursor+=2;
     }
     cursor = ql4;
     cursor += (ql4[16]<<24)|(ql4[17]<<16)|(ql4[18]<<8)|ql4[19];
     cursor += 16;
     maskpattern(editor_mode,&keep,&dummy);
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
     xtr = *cursor;
     for(k=0;k<8;k++)
     {
        if (8*i+k<GRIDX)
        {
        the_mask[j][8*i+k] &= keep;
        if ((xtr >> (7-k))&0x01 ) { the_mask[j][8*i+k] |= dummy; }
        }
     }
        cursor += 2;
     }
     update_dimension();
     update_demo();
    }
  }

  if ((moda & 0x01)&&ql8)
  {
     int k;
     unsigned short xtr;
     xpos = (ql8[4]<<8) | ql8[5];
     ypos = (ql8[6]<<8) | ql8[7];
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = ql8;
     cursor += (ql8[12]<<24)|(ql8[13]<<16)|(ql8[14]<<8)|ql8[15];
     cursor += 12;
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 8;
     top=0;
     colorpattern(editor_mode,&keep,&dummy);
     bottom=ypos;
     lefti=0;
     righti=xpos;
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<4;k++)
     {
        if (i*8+k*2<GRIDX)
        {
        the_sprite[j][i*8+k*2] &=  keep;
        the_sprite[j][i*8+k*2+1] &= keep;

        the_sprite[j][i*8+k*2] |= (
           ((xtr &
                   (0x0200 <<(6-2*k))
            )>>(7+6-2*k))
         |((xtr &
           (0x0003<<(6-2*k))
           )>>(6-2*k)))<<4;
        the_sprite[j][i*8+k*2+1] |= (
            ((xtr &
                    (0x0200 <<(6-2*k))
             )>>(7+6-2*k))
           |((xtr &
                    (0x03<<(6-2*k))
             )>>(6-2*k))
          )<<4;
        }
     }
     cursor+=2;
     }
     cursor = ql8;
     cursor += (ql8[16]<<24)|(ql8[17]<<16)|(ql8[18]<<8)|ql8[19];
     cursor += 16;
     maskpattern(editor_mode,&keep,&dummy);
     for(j=0;j<ypos;j++)
     for(i=0;i<round;i++)
     {
     xtr = *cursor;
     for(k=0;k<4;k++)
     {
        if (8*i+k*2<GRIDX)
        {
        the_mask[j][8*i+k*2] &= keep;
        the_mask[j][8*i+k*2+1] &= keep;
        if ((xtr >> (6-k*2))&0x01 )
        {
          the_mask[j][8*i+k*2] |= dummy;
          the_mask[j][8*i+k*2+1] |= dummy;
        
         }
        }
     }
        cursor += 2;
     }
     update_dimension();
     update_demo();
    }
  }

  editor_mode = kkkk;
  free(bloc);

}


void read_qpic(FILE * fd,int fd1)
{
unsigned short xpos,ypos,round;
struct stat buf;
unsigned long taille;
unsigned char * bloc;
unsigned char * cursor;
unsigned short width,key;
unsigned short height,row;
unsigned char mode;
unsigned char spare;

char deb[12];
unsigned char * q40,*ql4,*ql8;
int i,j;
unsigned long keep,dummy,mkeep,mset;
unsigned short *curs;
int kkkk = editor_mode;

  if (fstat(fd1,&buf))
  {
  Message_Report(DefaultColourSet(),mess[MS_FSTAT][conf_lang]);
  return;
  }
  taille = (unsigned long) buf.st_size;

  if (!taille)
  {
  Message_Report(DefaultColourSet(),mess[MS_FNULL][conf_lang]);
  return;
  }

  bloc = malloc(taille-10);
  if (!bloc)
  {
    Message_Report(DefaultColourSet(),mess[MS_MEMPB][conf_lang]);
    return;
  }
fread(&key,2,1,fd);
fread(&width,2,1,fd);
fread(&height,2,1,fd);
fread(&row,2,1,fd);
fread(&mode,1,1,fd);
fread(&spare,1,1,fd);


  fread(bloc,1,taille-10,fd);

  if ((key != 0x4AFC)||(width>GRIDX)||(height>GRIDY)||
     ((mode != 0)&&(mode != 8)&&(mode !=33))
     )
  {
     Message_Report(DefaultColourSet(),mess[MS_PICLOAD_ERR][conf_lang]);
     return;
  }

  if ((mode == 33))
  {
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor= bloc;
     round = (xpos+1) & 0xFFFE;
     editor_mode =40;
     top=0;
     bottom=ypos;
     lefti=0;
     colorpattern(editor_mode,&keep,&dummy);
     maskpattern(editor_mode,&mkeep,&mset);
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor= bloc + j * row;
     for(i=0;i<round;i++)
     {
        the_sprite[j][i] &= keep;
        the_sprite[j][i] |= ((*cursor)<<24) | ((*(cursor+1))<<16);
        the_mask[j][i] &= mkeep;
        the_mask[j][i] |= mset;
        cursor += 2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  if ((mode == 0))
  {
     int k;
     unsigned short xtr;
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = bloc;
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 4;
     top=0;
     bottom=ypos;
     lefti=0;
     colorpattern(editor_mode,&keep,&dummy);
     maskpattern(editor_mode,&mkeep,&mset);
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor = bloc + j * row;
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<8;k++)
     {
        if (i*8+k<GRIDX)
        {
        the_sprite[j][i*8+k] &= keep;
        the_sprite[j][i*8+k] |= (xtr & (0x0101 <<(7-k)))>>(7-k);
        the_mask[j][8*i+k] &= mkeep;
        the_mask[j][8*i+k] |= mset;
        }
     }
     cursor+=2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  if ((mode == 8))
  {
     int k;
     unsigned short xtr;
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 8;
     top=0;
     bottom=ypos;
     lefti=0;
     colorpattern(editor_mode,&keep,&dummy);
     maskpattern(editor_mode,&mkeep,&mset);
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor = bloc + j * row;
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<4;k++)
     {
        if (i*8+k*2<GRIDX)
        {
        the_sprite[j][i*8+k*2] &=  keep;
        the_sprite[j][i*8+k*2+1] &= keep;
        the_mask[j][8*i+k*2] &= mkeep;
        the_mask[j][8*i+k*2+1] &= mkeep;
        the_mask[j][8*i+k*2] |= mset;
        the_mask[j][8*i+k*2+1] |= mset;

        the_sprite[j][i*8+k*2] |= (
           ((xtr &
                   (0x0200 <<(6-2*k))
            )>>(7+6-2*k))
         |((xtr &
           (0x0003<<(6-2*k))
           )>>(6-2*k)))<<4;
        the_sprite[j][i*8+k*2+1] |= (
            ((xtr &
                    (0x0200 <<(6-2*k))
             )>>(7+6-2*k))
           |((xtr &
                    (0x03<<(6-2*k))
             )>>(6-2*k))
          )<<4;
        }
     }
     cursor+=2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  editor_mode = kkkk;
  free(bloc);

}

void read_mqpic(FILE * fd,int fd1)
{
unsigned short xpos,ypos,round;
struct stat buf;
unsigned long taille;
unsigned char * bloc;
unsigned char * cursor;
unsigned short width,key;
unsigned short height,row;
unsigned char mode;
unsigned char spare;
unsigned long keep,dummy;

char deb[12];
unsigned char * q40,*ql4,*ql8;
int i,j;
unsigned short *curs;
int kkkk = editor_mode;
  if (fstat(fd1,&buf))
  {
  Message_Report(DefaultColourSet(),mess[MS_FSTAT][conf_lang]);
  return;
  }
  taille = (unsigned long) buf.st_size;

  if (!taille)
  {
  Message_Report(DefaultColourSet(),mess[MS_FNULL][conf_lang]);
  return;
  }

  bloc = malloc(taille-10);
  if (!bloc)
  {
    Message_Report(DefaultColourSet(),mess[MS_MEMPB][conf_lang]);
    return;
  }
fread(&key,2,1,fd);
fread(&width,2,1,fd);
fread(&height,2,1,fd);
fread(&row,2,1,fd);
fread(&mode,1,1,fd);
fread(&spare,1,1,fd);


  fread(bloc,1,taille-10,fd);

  if ((key != 0x4AFC)||(width>GRIDX)||(height>GRIDY)||
     ((mode != 0)&&(mode != 8)&&(mode !=33))
     )
  {
     Message_Report(DefaultColourSet(),mess[MS_PICLOAD_ERR][conf_lang]);
     return;
  }

  if ((mode == 33))
  {
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor= bloc;
     round = (xpos+1) & 0xFFFE;
     editor_mode =40;
     top=0;
     bottom=ypos;
     maskpattern(editor_mode,&keep,&dummy);

     lefti=0;
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor= bloc + j * row;
     for(i=0;i<round;i++)
     {
        the_mask[j][i] &= keep;
        the_mask[j][i] |= (((*cursor)<<24) | ((*(cursor+1))<<16))? dummy:0;
        cursor += 2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  if ((mode == 0))
  {
     int k;
     unsigned short xtr;
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     cursor = bloc;
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 4;
     top=0;
     bottom=ypos;
     lefti=0;
     maskpattern(editor_mode,&keep,&dummy);
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor = bloc + j * row;
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<8;k++)
     {
        if (i*8+k<GRIDX)
        {
        the_mask[j][i*8+k] &= keep;
        the_mask[j][i*8+k] |= ((xtr & (0x0101 <<(7-k)))>>(7-k))?dummy:0;
        }
     }
     cursor+=2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  if ((mode == 8))
  {
     int k;
     unsigned short xtr;
     xpos = width;
     ypos = height;
     if ((xpos<=GRIDX)||(ypos<=GRIDY))
     {
     round = (xpos+15) & 0xFFF0;
     round /=8;
     editor_mode = 8;
     top=0;
     bottom=ypos;
     lefti=0;
     maskpattern(editor_mode,&keep,&dummy);
     righti=xpos;
     for(j=0;j<ypos;j++)
     {
     cursor = bloc + j * row;
     for(i=0;i<round;i++)
     {
     xtr = ((*cursor)<<8) | (*(cursor+1));
     for(k=0;k<4;k++)
     {
        if (i*8+k*2<GRIDX)
        {
        the_mask[j][8*i+k*2] &= keep;
        the_mask[j][8*i+k*2+1] &= keep;

        the_mask[j][i*8+k*2] |= (
           ((xtr &
                   (0x0200 <<(6-2*k))
            )>>(7+6-2*k))
         |((xtr &
           (0x0003<<(6-2*k))
           )>>(6-2*k)))<<8 ? dummy:0;
        the_mask[j][i*8+k*2+1] |= (
            ((xtr &
                    (0x0200 <<(6-2*k))
             )>>(7+6-2*k))
           |((xtr &
                    (0x03<<(6-2*k))
             )>>(6-2*k))
          )<<8 ? dummy : 0;
        }
     }
     cursor+=2;
     }
     }
     update_dimension();
     update_demo();
    }
  }

  editor_mode = kkkk;
  free(bloc);

}
